import { DeclarationReflection, ProjectReflection, ReflectionCategory, ReflectionGroup, TypeDocOptions } from 'typedoc';
import { NavigationItem } from '../theme/models';
import { MarkdownTheme } from './theme';
export declare class NavigationContext {
    theme: MarkdownTheme;
    options: Partial<TypeDocOptions>;
    navigation: NavigationItem[];
    constructor(theme: MarkdownTheme, options: Partial<TypeDocOptions>);
    getNavigation(project: ProjectReflection): NavigationItem[];
    buildNavigationFromProject(project: ProjectReflection | DeclarationReflection): void;
    getCategoryGroupChildren(group: ReflectionCategory): any;
    getGroupChildren(group: ReflectionGroup): any;
    getChildrenOrGroups(reflection: DeclarationReflection): any;
}
