"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.inheritance = void 0;
const elements_1 = require("../../../support/elements");
function inheritance(context, reflection, headingLevel) {
    const md = [];
    if (reflection.implementationOf) {
        if (headingLevel !== -1) {
            md.push((0, elements_1.heading)(headingLevel, 'Implementation of'));
        }
        md.push(typeAndParent(context, reflection.implementationOf));
    }
    if (reflection.inheritedFrom) {
        if (headingLevel !== -1) {
            md.push((0, elements_1.heading)(headingLevel, 'Inherited from'));
        }
        md.push(typeAndParent(context, reflection.inheritedFrom));
    }
    if (reflection.overwrites) {
        if (headingLevel !== -1) {
            md.push((0, elements_1.heading)(headingLevel, 'Overrides'));
        }
        md.push(typeAndParent(context, reflection.overwrites));
    }
    return md.join('\n\n');
}
exports.inheritance = inheritance;
const typeAndParent = (context, props) => {
    var _a, _b, _c;
    if (props) {
        if ('elementType' in props) {
            return typeAndParent(context, props.elementType) + '[]';
        }
        else {
            if (props.reflection) {
                const name = props.reflection.getFriendlyFullName();
                const url = ((_a = props.reflection) === null || _a === void 0 ? void 0 : _a.url) || ((_c = (_b = props.reflection) === null || _b === void 0 ? void 0 : _b.parent) === null || _c === void 0 ? void 0 : _c.url);
                const output = url
                    ? (0, elements_1.link)((0, elements_1.backTicks)(name), context.relativeURL(url))
                    : (0, elements_1.backTicks)(name);
                return output;
            }
            else {
                return (0, elements_1.backTicks)(props.toString());
            }
        }
    }
    return 'void';
};
