"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.referenceMember = void 0;
const typedoc_1 = require("typedoc");
/**
 * @category Partials
 */
function referenceMember(context, props) {
    let referenced = props.tryGetTargetReflectionDeep();
    if (!referenced) {
        return `Re-exports ${props.name}`;
    }
    if ((referenced === null || referenced === void 0 ? void 0 : referenced.kindOf(typedoc_1.ReflectionKind.TypeLiteral)) && referenced.parent) {
        referenced = referenced === null || referenced === void 0 ? void 0 : referenced.parent;
    }
    if (!(referenced === null || referenced === void 0 ? void 0 : referenced.url)) {
        return `Re-exports ${referenced.name}`;
    }
    if (props.name === referenced.name) {
        return `Re-exports [${referenced.name}](${context.urlTo(referenced)})`;
    }
    return `Renames and re-exports [${referenced.name}](${context.urlTo(referenced)})`;
}
exports.referenceMember = referenceMember;
