"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pageTitle = void 0;
const typedoc_1 = require("typedoc");
const helpers_1 = require("../../helpers");
/**
 * @category Partials
 */
function pageTitle(context, page) {
    var _a;
    const memberPageTitle = context.options.getValue('memberPageTitle');
    const name = (0, helpers_1.getMemberTitle)(page.model);
    if (((_a = page.model) === null || _a === void 0 ? void 0 : _a.url) === page.project.url) {
        const projectName = (0, helpers_1.getProjectDisplayName)(page.project, context.options.getValue('includeVersion'));
        return context.options
            .getValue('indexPageTitle')
            .replace('{projectName}', projectName);
    }
    if (page.model.kindOf(typedoc_1.ReflectionKind.Module)) {
        return page.model.packageVersion
            ? `${name} - v${page.model.packageVersion}`
            : name;
    }
    return memberPageTitle
        .replace('{name}', name)
        .replace('{kind}', typedoc_1.ReflectionKind.singularString(page.model.kind));
}
exports.pageTitle = pageTitle;
